function [B, C, S] = subpixelWarp(x, motionParams, optMatStruct)

    xy = optMatStruct.xy;
    C =  optMatStruct.C;
    numFrames = optMatStruct.numFrames;
    M = optMatStruct.Size(1);
    N = optMatStruct.Size(2);
    alpha = motionParams;
    
	for k = 2 :numFrames

		Calpha = C * alpha(:,k);
        dxy = Calpha - xy;
        len = size(dxy);
		
		% Coordinate change
        d_xk = dxy(1:len/2);
        d_yk = dxy(len/2 + 1:len);
		
		% Shifted and rotated S(alpha)f derivation
        dk = d_xk - floor(d_xk);
        ek = d_yk - floor(d_yk);
        d_xk = reshape(d_xk, [M, N]);
        d_yk = reshape(d_yk, [M, N]);
		
		% Corner coordinates
        bl = getShiftMatrix('rep', ceil(d_xk), floor(d_yk));
        br = getShiftMatrix('rep', ceil(d_xk), ceil(d_yk));
        tl = getShiftMatrix('rep', floor(d_xk), floor(d_yk));
        tr  = getShiftMatrix('rep', floor(d_xk), ceil(d_yk));

		% Bilinear interpolation
        Sek = createSparse(ek);
        S_ek = createSparse(1 - ek);
        Sdk = createSparse(dk);
        S_dk = createSparse(1 - dk);
 
        S{k} = (Sek * S_dk * tr) + (Sek * Sdk * br) + (S_ek * S_dk * tl) +(S_ek * Sdk * bl);
		
		% B derivation
		FBL = createSparse(bl * x); 
		FBR = createSparse(br * x); 
		FTL = createSparse(tl * x); 
		FTR = createSparse(tr * x);
		Bt1 = S_ek * (FBL - FTL) + Sek * (FBR - FTR);
		Bt2 = S_dk * (FTR - FTL) + Sdk * (FBR - FBL);
		B{k} = cat(2, Bt1, Bt2);
        
    end